-- YGREC8/INC16_tb.vhdl
-- version lun. nov. 13 01:45:27 CET 2017 by Yann Guidon (whygee@f-cpu.org)
-- Released under the GNU AGPLv3 license

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
Library work;
    use work.all;
    use work.ygrec8_utils.all;

entity INC16_tb is
end INC16_tb;

architecture plip of INC16_tb is
  signal V : std_logic := '0';
  signal A, Y : std_logic_vector(15 downto 0) := "0000000000000000";
begin

  tb: entity INC16 port map (
     A => A,
     Y => Y,
     V => V);

  bench: process
    variable i: integer := 0;
    variable expected : std_logic_vector(16 downto 0);
  begin

    for i in 0 to 65535 loop
      A <= std_logic_vector(to_unsigned(i, 16));
      wait for 1 ns;

      expected := std_logic_vector(to_unsigned(i+1, 17));
      if expected /= (V & Y) then
        report "Error at " & integer'image(i)
          & " " & SLV_to_bin(A)
          & " " & std_logic'image(V)
          & " " & SLV_to_bin(Y);
      end if;
    end loop;

    wait;
  end process;

end plip;
