-- YGREC8/YGREC8_def.vhdl
-- created lun. nov. 13 00:47:55 CET 2017 by Yann Guidon (whygee@f-cpu.org)
-- version lun. nov. 13 02:14:43 CET 2017
-- Released under the GNU AGPLv3 license
--
-- These are the definitions of YGREC8,
-- shared by the core and other files that instatiate it.

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;

package ygrec8_def is

  constant Op_OR   : std_logic_vector(3 downto 0) := "0000";
  constant Op_XOR  : std_logic_vector(3 downto 0) := "0001";
  constant Op_AND  : std_logic_vector(3 downto 0) := "0010";
  constant Op_ANDN : std_logic_vector(3 downto 0) := "0011";
  constant Op_CMPU : std_logic_vector(3 downto 0) := "0100";
  constant Op_CMPS : std_logic_vector(3 downto 0) := "0101";
  constant Op_SUB  : std_logic_vector(3 downto 0) := "0110";
  constant Op_ADD  : std_logic_vector(3 downto 0) := "0111";
  constant Op_SHR  : std_logic_vector(3 downto 0) := "1000";
  constant Op_SHL  : std_logic_vector(3 downto 0) := "1001";
  constant Op_SAR  : std_logic_vector(3 downto 0) := "1010";
  constant Op_ROL  : std_logic_vector(3 downto 0) := "1011";
  constant Op_IN   : std_logic_vector(3 downto 0) := "1100";
  constant Op_OUT  : std_logic_vector(3 downto 0) := "1101";
  constant Op_CALL : std_logic_vector(3 downto 0) := "1110";
  constant Op_MOV  : std_logic_vector(3 downto 0) := "1111";

  constant Reg_D1 : std_logic_vector(2 downto 0) := "000";
  constant Reg_A1 : std_logic_vector(2 downto 0) := "001";
  constant Reg_D2 : std_logic_vector(2 downto 0) := "010";
  constant Reg_A2 : std_logic_vector(2 downto 0) := "011";
  constant Reg_R1 : std_logic_vector(2 downto 0) := "100";
  constant Reg_R2 : std_logic_vector(2 downto 0) := "101";
  constant Reg_R3 : std_logic_vector(2 downto 0) := "110";
  constant Reg_PC : std_logic_vector(2 downto 0) := "111";

  constant Cond_A : std_logic_vector(2 downto 0) := "000";
  constant Cond_C : std_logic_vector(2 downto 0) := "001";
  constant Cond_S : std_logic_vector(2 downto 0) := "010";
  constant Cond_Z : std_logic_vector(2 downto 0) := "011";
  constant Cond_0 : std_logic_vector(2 downto 0) := "100";
  constant Cond_1 : std_logic_vector(2 downto 0) := "101";
  constant Cond_2 : std_logic_vector(2 downto 0) := "110";
  constant Cond_3 : std_logic_vector(2 downto 0) := "111";

end ygrec8_def;

--package body ygrec8_def is
-- empty
--end ygrec8_def;
